'Program komunikujcy si z pamicia 24C02 (2k - 256*8) - pojemno 256 bajtw
'Komunikacja z pamiecia odbywa sie przy pomocy magistrali I2C
'Mikrokontroler ATMEGA8 taktowany czestotliwoscia 8MHz
'W programie do pamieci (komorki 0...255) wpisywane sa wartosci liczbowe od 0 do 255,
'nastepnie dane zapisane do pamieci sa odczytywane i weryfikowane pod wzgledem poprawnosci zapisu
'zarowno wartosci danych zapisywanych jak i odczytywanych sa wysylane do terminala poprzez interfejs RS232.
'Predkosc komunikacji przez RS232 wynosi 9600 bodow.
'W przypadku bledu zapisu do pamieci wysylany jest do terminala stosowny komunikat
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o czstotliwoci oscylatora taktujacego mikrokontroler
$baud = 9600                                                'informuje o predkosci transmisji interfejsu RS232

Const Adr_w = 160                                           'adres zapisu danej do pamieci EEPROM
Const Adr_r = 161                                           'adres odczytu danej do pamieci EEPROM

Config Sda = Portc.4                                        'konfiguracja linii SDA interfejsu I2C
Config Scl = Portc.3                                        'konfiguracja linii SCL interfejsu I2C
Config I2cdelay = 5                                         'konfiguracja opoznienia (czestotliwosci) linii zegarowej SCL

Declare Sub Zap_eeprom(byval Adres As Byte , Byval Dana As Byte)       'procedura zapisu danej do pamieci
Declare Sub Odc_eeprom(byval Adres As Byte , Dana As Byte)  'procedura odczytu danej z pamieci

Dim Adres As Byte                                           'zmienna adresu komorki pamieci
Dim Dana As Byte                                            'zmienna zmienna na odczytana lub zapisana dana do pamieci
Dim I As Byte                                               'zmienna licznikowa

Print "Zapis"                                               'wyslanie do terminala tekstu

For I = 0 To 255                                            'petla wykonywana dla I=0 do I=255
  Call Zap_eeprom(i , I)                                    'zapis do EEPROM wartosci zmiennej I pod adres wskazywany przez I
  Print Hex(i) ; " ";                                       'wyslanie do terminala wartosci zapisywanej do EEPROM w postaci szesnastkowej
Next I                                                      'zwiekszenie o 1 wartosci I

Print                                                       'wyslanie do terminala wiersza odstepu
Print "Odczyt i weryfikacja"                                'wyslanie do terminala tekstu

For I = 0 To 255                                            'petla wykonywana dla I=0 do I=255
  Call Odc_eeprom(i , Dana)                                 'odczytanie z EEPROM wartosc z komorki o adresie wskazywanym przez I
  If Dana = I Then                                          '--weryfikacja danych-- jesli Dana = I to
    Print Hex(dana) ; " ";                                  'wyslanie do terminala odczytanej wartosci z pamieci w postaci szesnastkowej
  Else                                                      'w przeciwnym razie
    Print "Dane nieprawidlowe"                              'wyslanie do terminala tekstu
    Exit For                                                'opuszczenie petli For
  End If
Next I                                                      'zwiekszenie o 1 wartosci I
End                                                         'koniec programu

Sub Zap_eeprom(byval Adres As Byte , Byval Dana As Byte)    'procedura zapisu danej do EEPROM
  I2cstart                                                  'start transmisji
  I2cwbyte Adr_w                                            'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adres                                            'adres komorki pamieci
  I2cwbyte Dana                                             'zapis danej
  I2cstop                                                   'koniec transmisji
  Waitms 10                                                 'opoznienie 10 ms
End Sub                                                     'koniec procedury

Sub Odc_eeprom(byval Adres As Byte , Dana As Byte)          'procedura odczytu danej do EEPROM
  I2cstart                                                  'start transmisji
  I2cwbyte Adr_w                                            'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adres                                            'adres komorki pamieci
  I2cstart                                                  'ponowny start transmisji
  I2cwbyte Adr_r                                            'zapis adresu ukladu pamieci do odczytu
  I2crbyte Dana , Nack                                      'odczyt bajta danej - bez potwierdzenia sygnaem ACK
  I2cstop                                                   'koniec transmisji
End Sub                                                     'koniec procedury