'Program komunikujcy si z pamicia 24C16 (16k - 2048*8) - pojemno 2048 bajtw
'Komunikacja z pamiecia odbywa sie przy pomocy magistrali I2C
'Mikrokontroler ATMEGA8 taktowany z czestotliwoscia 8MHz
'Pamiec posiada 8 stron z ktorych kazda ma 256 komorek co daje pojemno 2kB (2048 komorek)
'W programie do pamieci (komorki 0...2048) wpisywane sa wartosci liczbowe numerow stron do ktrych nastepuje zapis.
'Nastepnie dane zapisane do pamieci sa odczytywane i weryfikowane pod wzgledem poprawnosci zapisu
'Zarowno wartosci danych zapisywanych jak i odczytywanych sa wysylane do terminala poprzez interfejs RS232.
'Predkosc komunikacji przez RS232 wynosi 9600 bodow.
'W przypadku bledu zapisu do pamieci wysylany jest do terminala stosowny komunikat
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o czstotliwoci oscylatora taktujacego mikrokontroler
$baud = 9600                                                'informuje o predkosci transmisji interfejsu RS232

Const Adr_w = 160                                           'adres zapisu danej do pamieci EEPROM
Const Adr_r = 161                                           'adres odczytu danej do pamieci EEPROM

Config Sda = Portc.4                                        'konfiguracja linii SDA interfejsu I2C
Config Scl = Portc.3                                        'konfiguracja linii SCL interfejsu I2C
Config I2cdelay = 5                                         'konfiguracja opoznienia (czestotliwosci) linii zegarowej SCL

Declare Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)       'procedura zapisu danej do pamieci
Declare Sub Odc_eeprom(byval Adres As Word , Dana As Byte)  'procedura odczytu danej z pamieci

Dim Adres As Word                                           'zmienna adresu komorki pamieci
Dim Dana As Byte                                            'zmienna zmienna na odczytana lub zapisana dana do pamieci
Dim I As Word                                               'zmienna licznikowa
Dim Temp As Byte                                            'zmienna pomocnicza
Dim Zm_pom As Word                                          'zmienna pomocnicza do przeliczenia adresu

Print "Zapis"                                               'wyslanie do terminala tekstu

For I = 0 To 2047                                           'petla wykonywana dla I=0 do I=2047
  Zm_pom = I / 256                                          'obliczenie numeru strony pamieci
  Dana = Zm_pom                                             'zapis numeru strony do zmiennej dana
  Call Zap_eeprom(i , Dana)                                 'zapis do EEPROM wartosci zmiennej dana pod adres wskazywany przez I
  Print Hex(dana) ; " ";                                    'wyslanie do terminala wartosci zapisywanej do EEPROM w postaci szesnastkowej
Next I                                                      'zwiekszenie o 1 wartosci I

Print                                                       'wyslanie do terminala wiersza odstepu
Print "Odczyt i weryfikacja"                                'wyslanie do terminala tekstu

For I = 0 To 2047                                           'petla wykonywana dla I=0 do I=2047
  Call Odc_eeprom(i , Dana)                                 'odczytanie z EEPROM wartosc z komorki o adresie wskazywanym przez I
  Zm_pom = I / 256                                          'obliczenie odczytywanej strony pamieci
  If Dana = Zm_pom Then                                     '--weryfikacja danych-- jesli Dana = zm_pom - czyli numerowi strony to
    Print Hex(dana) ; " ";                                  'wyslanie do terminala odczytanej wartosci z pamieci w postaci szesnastkowej
  Else                                                      'w przeciwnym razie
    Print "Dane nieprawidlowe"                              'wyslanie do terminala tekstu
    Exit For                                                'opuszczenie petli For
  End If
Next I                                                      'zwiekszenie o 1 wartosci I
End                                                         'koniec programu

Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)    'procedura zapisu danej do EEPROM
  Zm_pom = Adres / 256                                      'obliczenie adresu strony
  Temp = Low(zm_pom)                                        'zapis do temp mniej znaczacego bajta zmiennej zm_pom
  Adres = Adres Mod 256                                     'obliczenie adresu komorki pamieci
  Shift Temp , Left , 1                                     'przesuniecie wartosci w temp o jedna pozycje w lewo (mnozenie przez 2)
  Temp = Temp + Adr_w                                       'obliczenie adresu pamieci z uwzglednieniem stron
  I2cstart                                                  'start transmisji
  I2cwbyte Temp                                             'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adres                                            'adres komorki pamieci
  I2cwbyte Dana                                             'zapis danej
  I2cstop                                                   'koniec transmisji
  Waitms 7                                                  'opoznienie 7 ms
End Sub                                                     'koniec procedury

Sub Odc_eeprom(byval Adres As Word , Dana As Byte)          'procedura odczytu danej do EEPROM
  Zm_pom = Adres / 256                                      'obliczenie adresu strony
  Temp = Low(zm_pom)                                        'zapis do temp mniej znaczacego bajta zmiennej zm_pom
  Adres = Adres Mod 256                                     'obliczenie adresu komorki pamieci
  Shift Temp , Left , 1                                     'przesuniecie wartosci w temp o jedna pozycje w lewo (mnozenie przez 2)
  Temp = Temp + Adr_w                                       'obliczenie adresu pamieci z uwzglednieniem stron
  I2cstart                                                  'start transmisji
  I2cwbyte Temp                                             'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adres                                            'adres komorki pamieci
  I2cstart                                                  'ponowny start transmisji
  Incr Temp                                                 'zwiekszenie temp o jeden - uzyskanie adresu do odczytu danej z pamieci
  I2cwbyte Temp                                             'zapis adresu ukladu pamieci do odczytu
  I2crbyte Dana , Nack                                      'odczyt bajta danej - bez potwierdzenia sygnaem ACK
  I2cstop                                                   'koniec transmisji
End Sub                                                     'koniec procedury