'Program komunikujcy si z pamicia 24C64 (8k - 256*32) - pojemno 8192 bajtw
'Komunikacja z pamiecia odbywa sie przy pomocy magistrali I2C
'Mikrokontroler ATMEGA8 taktowany z czestotliwoscia 8MHz
'Pamiec posiada 32 strony z ktorych kazda ma 256 komorek co daje pojemno 8kB (8192 komorek)
'W programie do pamieci (komorki 0...8192) wpisywane sa wartosci liczbowe numerow stron do ktrych nastepuje zapis.
'Nastepnie dane zapisane do pamieci sa odczytywane i weryfikowane pod wzgledem poprawnosci zapisu
'Zarowno wartosci danych zapisywanych jak i odczytywanych sa wysylane do terminala poprzez interfejs RS232.
'Predkosc komunikacji przez RS232 wynosi 38400 bodow.
'W przypadku bledu zapisu do pamieci wysylany jest do terminala stosowny komunikat
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o czstotliwoci oscylatora taktujacego mikrokontroler
$baud = 38400                                               'informuje o predkosci transmisji interfejsu RS232

Const Adr_w = 160                                           'adres zapisu danej do pamieci EEPROM
Const Adr_r = 161                                           'adres odczytu danej do pamieci EEPROM

Config Sda = Portc.4                                        'konfiguracja linii SDA interfejsu I2C
Config Scl = Portc.3                                        'konfiguracja linii SCL interfejsu I2C
Config I2cdelay = 5                                         'konfiguracja opoznienia (czestotliwosci) linii zegarowej SCL

Declare Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)       'procedura zapisu danej do pamieci
Declare Sub Odc_eeprom(byval Adres As Word , Dana As Byte)  'procedura odczytu danej z pamieci

Dim Adres As Word                                           'zmienna adresu komorki pamieci
Dim Adr_h As Byte                                           'bardziej znaczaca polowka adresu
Dim Adr_l As Byte                                           'mniej znaczaca polowka adresu
Dim Dana As Byte                                            'zmienna zmienna na odczytana lub zapisana dana do pamieci
Dim I As Byte                                               'zmienna licznikowa
Dim J As Byte                                               'zmienna licznikowa

Print "Zapis"                                               'wyslanie do terminala tekstu
I = 0                                                       'zerowanie zmiennej I
J = 0                                                       'zerowanie zmiennej J

For Adres = 0 To 8191                                       'petla wykonywana dla I=0 do I=255
  Call Zap_eeprom(adres , J)                                'zapis do EEPROM wartosci zmiennej I pod adres wskazywany przez I
  Print Hex(j) ; " ";                                       'wyslanie do terminala wartosci zapisywanej do EEPROM w postaci szesnastkowej
  Incr I                                                    'zwiekszenie o jeden zmiennej I
  If I = 0 Then                                             'jesli I=0 to
    Incr J                                                  'zwiekszenie o jeden zmiennej J
  End If
Next I                                                      'zwiekszenie o 1 wartosci I

Print                                                       'wyslanie do terminala wiersza odstepu
Print "Odczyt i weryfikacja"                                'wyslanie do terminala tekstu
I = 0                                                       'zerowanie zmiennej I
J = 0                                                       'zerowanie zmiennej J

For Adres = 0 To 8191                                       'petla wykonywana dla I=0 do I=255
  Call Odc_eeprom(adres , Dana)                             'odczytanie z EEPROM wartosc z komorki o adresie wskazywanym przez I
  If Dana = J Then                                          '--weryfikacja danych-- jesli Dana = I to
    Print Hex(dana) ; " ";                                  'wyslanie do terminala odczytanej wartosci z pamieci w postaci szesnastkowej
  Else                                                      'w przeciwnym razie
    Print "Dane nieprawidlowe"                              'wyslanie do terminala tekstu
    Exit For                                                'opuszczenie petli For
  End If
  Incr I                                                    'zwiekszenie o jeden zmiennej I
  If I = 0 Then                                             'jesli I=0 to
    Incr J                                                  'zwiekszenie o jeden zmiennej J
  End If
Next I                                                      'zwiekszenie o 1 wartosci I
End                                                         'koniec programu

Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)    'procedura zapisu danej do EEPROM
  Adr_h = High(adres)                                       'zapis do Adr_h bardziej znaczacej polowki adresu
  Adr_l = Low(adres)                                        'zapis do Adr_l mniej znaczacej polowki adresu
  I2cstart                                                  'start transmisji
  I2cwbyte Adr_w                                            'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adr_h                                            'bardziej znaczacy adres komorki pamieci
  I2cwbyte Adr_l                                            'mniej znaczacy adres komorki pamieci
  I2cwbyte Dana                                             'zapis danej
  I2cstop                                                   'koniec transmisji
  Waitms 7                                                  'opoznienie 7 ms
End Sub                                                     'koniec procedury

Sub Odc_eeprom(byval Adres As Word , Dana As Byte)          'procedura odczytu danej do EEPROM
  Adr_h = High(adres)                                       'zapis do Adr_h bardziej znaczacej polowki adresu
  Adr_l = Low(adres)                                        'zapis do Adr_l mniej znaczacej polowki adresu
  I2cstart                                                  'start transmisji
  I2cwbyte Adr_w                                            'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adr_h                                            'bardziej znaczacy adres komorki pamieci
  I2cwbyte Adr_l                                            'mniej znaczacy adres komorki pamieci
  I2cstart                                                  'ponowny start transmisji
  I2cwbyte Adr_r                                            'zapis adresu ukladu pamieci do odczytu
  I2crbyte Dana , Nack                                      'odczyt bajta danej - bez potwierdzenia sygnaem ACK
  I2cstop                                                   'koniec transmisji
End Sub                                                     'koniec procedury