'Program komunikujcy si z pamicia DataFlash AT45DB011B - pojemno 135168 bajtow (1081344 bitow)
'Pamiec posiada 512 stron z ktorych kazda sklada sie z 264 bajtow.
'Pamiec ma takze wbudowany jeden bufor o pojemnosci 264 bajtow do ktorego mozna zaladowac jedna strone pamieci
'Komunikacja z pamiecia odbywa sie przy pomocy magistrali SPI
'Mikrokontroler ATMEGA8 taktowany czestotliwoscia 8MHz
'W programie do pamieci (komorki 0...135168) wpisywane sa wartosci liczbowe od 0 do 255,
'nastepnie dane zapisane do pamieci sa odczytywane i weryfikowane pod wzgledem poprawnosci zapisu
'zarowno wartosci danych zapisywanych jak i odczytywanych sa wysylane do terminala poprzez interfejs RS232.
'Predkosc komunikacji przez RS232 wynosi 38400 bodow.
'W przypadku bledu zapisu do pamieci wysylany jest do terminala stosowny komunikat
'Ze wzgledu na znaczna pojemnosc pamieci zarowno odczyt jak i zapis calej pamieci moze potrwac kilkanascie minut.
'W programie pamiec DataFlash zostala skonfigurowana jako typowa pamiec EEPROM,
'czyli jest mozliwosc zapisania danej pod dowolnie wybrany adres pamieci
'Taki tryb pracy pamieci powoduje dos dlugotrwaly zapis jednej komporki pamieci,
'niz ma to miejsce w przypadku zapisu strony z wykorzystaniem bufora.
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator o czstotliwoci oscylatora taktujacego mikrokontroler
$baud = 38400                                               'informuje o predkosci transmisji interfejsu RS232

Config Pinb.2 = Output                                      'linia PB2 jako wyjsciowa (CS)
Config Spi = Soft , Din = Pinb.4 , Dout = Portb.3 , Ss = None , Clock = Portb.5       'konfiguracja interfejsu SPI

Declare Sub Zap_eeprom(byval Adres As Long , Byval Dana As Byte)       'procedura zapisu danej do pamieci
Declare Sub Odc_eeprom(byval Adres As Long , Dana As Byte)  'procedura odczytu danej z pamieci

Dim Adres As Long                                           'zmienna adresu komorki pamieci
Dim Dana As Byte                                            'zmienna zmienna na odczytana lub zapisana dana do pamieci
Dim I As Long                                               'zmienna licznikowa
Dim Temp As Byte                                            'zmienna pomocnicza
Dim Temp1 As Byte                                           'zmienna pomocnicza
Dim Temp2 As Byte                                           'zmienna pomocnicza
Dim Temp3 As Byte                                           'zmienna pomocnicza
Dim Zm_pom As Word                                          'zmienna pomocnicza
Dim Temp4 As Long                                           'zmienna pomocnicza
Dim J As Byte                                               'zmienna licznikowa

Sck Alias Portb.5                                           'przypisanie nazwie Portb.5 aliasu Sk
Cs Alias Portb.2                                            'przypisanie nazwie Portb.2 aliasu Cs

Spiinit                                                     'inicjacja interfejsu SPI
Set Cs                                                      'ustawienie linii Cs
Reset Sck                                                   'zerowanie linii Sck
Waitms 200                                                  'opoznienie 200 ms
Print "Zapis"                                               'wyslanie do terminala tekstu
J = 0                                                       'wyzerowanie zmiennej J
For I = 0 To 135167                                         'petla wykonywana dla I=0 do I=135167
  Call Zap_eeprom(i , J)                                    'zapis do EEPROM wartosci zmiennej I pod adres wskazywany przez I
  Print Hex(j) ; " ";                                       'wyslanie do terminala wartosci zapisywanej do EEPROM w postaci szesnastkowej
  Incr J                                                    'zwiekszenie o jeden wartosci J
Next I                                                      'zwiekszenie o 1 wartosci I

Print                                                       'wyslanie do terminala wiersza odstepu
Print "Odczyt i weryfikacja"                                'wyslanie do terminala tekstu
J = 0                                                       'wyzerowanie zmiennej J
For I = 0 To 135167                                         'petla wykonywana dla I=0 do I=135167
  Call Odc_eeprom(i , Dana)                                 'odczytanie z EEPROM wartosc z komorki o adresie wskazywanym przez I
  If Dana = 3 Then                                          '--weryfikacja danych-- jesli Dana = I to
    Print Hex(dana) ; " ";                                  'wyslanie do terminala odczytanej wartosci z pamieci w postaci szesnastkowej
  Else                                                      'w przeciwnym razie
    Print "Dane nieprawidlowe"                              'wyslanie do terminala tekstu
    Exit For                                                'opuszczenie petli For
  End If
  Incr J                                                    'wyzerowanie zmiennej J
Next I                                                      'zwiekszenie o 1 wartosci I
End                                                         'koniec programu

Sub Zap_eeprom(byval Adres As Long , Byval Dana As Byte)    'procedura zapisu danej do EEPROM
  Temp4 = Adres / 264                                       'obliczenie adresu strony
  Zm_pom = Temp4                                            'przepisanie adresu strony
  Temp1 = 0                                                 'wyzerowanie Temp1
  Temp1.1 = Zm_pom.8                                        'zapis do bitu 1 zmiennej Temp1 bitu 8 zmiennej Zm_pom
  Temp1.0 = Zm_pom.7                                        'zapis do bitu 0 zmiennej Temp1 bitu 7 zmiennej Zm_pom
  Adres = Adres Mod 264                                     'obliczenie adresu w stronie
  Shift Zm_pom , Left , 1                                   'przesuniecie wartosci w zm_pom o jedna pozycje w lewo (mnozenie przez 2)
  Temp2 = Low(zm_pom)                                       'przepisanie do Temp2 mniej znaczacej wartosci zmiennej zm_pom
  Temp2.0 = Adres.8                                         'zapis do bitu 0 zmiennej Temp2 bitu 8 zmiennej Adres
  Zm_pom = Adres                                            'przepisanie wartosci z Adres do Zm_pom
  Temp3 = Zm_pom                                            'przepisanie wartosci z zm_pom do Temp3
  Set Sck                                                   'ustawienie linii Sck
  Reset Cs                                                  'zerowanie linii Cs
  Temp = &H53                                               'kod rozkazu odczytu strony do bufora pamieci
  Spiout Temp , 1                                           'wyslanie rozkazu
  Spiout Temp1 , 1                                          'wyslanie adresu
  Spiout Temp2 , 1                                          'wyslanie adresu
  Spiout Temp3 , 1                                          'wyslanie adresu
  Set Cs                                                    'ustawienie linii Cs
  Delay                                                     'opoznienie
  Set Sck                                                   'ustawienie linii Sck
  Reset Cs                                                  'zerowanie linii Cs
  Temp = &H82                                               'kod rozkazu zapisu strony do pamieci EEPROM (poprzez bufor)
  Spiout Temp , 1                                           'wyslanie rozkazu
  Spiout Temp1 , 1                                          'wyslanie adresu
  Spiout Temp2 , 1                                          'wyslanie adresu
  Spiout Temp3 , 1                                          'wyslanie adresu
  Spiout Dana , 1                                           'wyslanie zapisywanej danej
  Set Cs                                                    'ustawienie linii Cs
  Waitms 28                                                 'opoznienie 28 ms
End Sub                                                     'koniec procedury

Sub Odc_eeprom(byval Adres As Long , Dana As Byte)          'procedura odczytu danej do EEPROM
  Temp4 = Adres / 264                                       'obliczenie adresu strony
  Zm_pom = Temp4                                            'przepisanie adresu strony
  Temp1 = 0                                                 'wyzerowanie Temp1
  Temp1.1 = Zm_pom.8                                        'zapis do bitu 1 zmiennej Temp1 bitu 8 zmiennej Zm_pom
  Temp1.0 = Zm_pom.7                                        'zapis do bitu 0 zmiennej Temp1 bitu 7 zmiennej Zm_pom
  Adres = Adres Mod 264                                     'obliczenie adresu w stronie
  Shift Zm_pom , Left , 1                                   'przesuniecie wartosci w zm_pom o jedna pozycje w lewo (mnozenie przez 2)
  Temp2 = Low(zm_pom)                                       'przepisanie do Temp2 mniej znaczacej wartosci zmiennej zm_pom
  Temp2.0 = Adres.8                                         'zapis do bitu 0 zmiennej Temp2 bitu 8 zmiennej Adres
  Zm_pom = Adres                                            'przepisanie wartosci z Adres do Zm_pom
  Temp3 = Zm_pom                                            'przepisanie wartosci z zm_pom do Temp3
  Reset Sck                                                 'zerowanie linii Sck
  Reset Cs                                                  'zerowanie linii Cs
  Temp = &H52                                               'kod rozkazu odczytania danej z pamieci pod wybranym adresem
  Spiout Temp , 1                                           'wyslanie rozkazu
  Spiout Temp1 , 1                                          'wyslanie adresu
  Spiout Temp2 , 1                                          'wyslanie adresu
  Spiout Temp3 , 1                                          'wyslanie adresu
  Temp = 0                                                  'zrowanie wartosci Temp
  Spiout Temp , 4                                           'wyslanie 4 bajtow o wartosci 0
  Spiin Dana , 1                                            'odczyt danej z pamieci EEPROM
  Set Cs                                                    'ustawienie linii Cs
End Sub                                                     'koniec procedury